Subject: [RTG-DIR] RtgDir Early Review: draft-ietf-idr-bgp-flowspec-oid-11.txt

From: Geoff Huston <[email-masked]>
Date: Fri, 3 Jul 2020 13:49:19 +1000

resend to include the document authors.

Hello

I have been selected to do a routing directorate “early” review of this draft: https://datatracker.ietf.org/doc/draft-ietf-idr-bgp-flowspec-oid

The routing directorate will, on request from the working group chair, perform an “early” review of a draft before it is submitted for publication to the IESG. The early review can be performed at any time during the draft’s lifetime as a working group document. The purpose of the early review depends on the stage that the document has reached.

A co-chair of the IDR, Susan Hares, has requested an early review of this document

For more information about the Routing Directorate, please see http://trac.tools.ietf.org/area/rtg/trac/wiki/RtgDir

Document: draft-ietf-idr-bgp-flowspec-oid-11.txt
Reviewer: Geoff Huston
Review Date: 3 July 2020
Intended Status: Standards Track

Summary: 

I have some major concerns about this document, mainly relating to updates to an RFC-to-be even before the original document has been published as an RFC. I assume that there are reasons why the original document (draft-ietf-idr-rfc5575bis) was not updated directly, particularly given that the initial drafts of this validation revision document predates the initial drafts rfc5575bis document. It is therefore unclear why the process of review of the 5575bis document has not adopted this revised specification during the course of the development of the bis document during its development. The question I am left with is: What has changed in recent times that would make revision of a published RFC more likely than revision of an in-progress working group draft?

Comments:

The document clearly describes the motivation of the revised validation  procedures (reduced operational complexity for dissemination of BGP policy rules when using a route controller).

The proposed revision is susceptible to misunderstanding. It takes the set of three conditions specified in RFC5575bis, where all the conditions must hold for the Flow Specification NLRI to be validated, and altering one of these condition to be two conditions, either of which can hold. The three further comments (labelled 1 through 3 in section 4.1) are unclear in their intent. It is also unclear why the second paragraph in section 4.1 is labelled "a." when there is no subsequent section labelled "b.". The indentation of the succeeding paras of section 4.1 suggest that they are part of the redefinition of step(b) of the validation procedures in RFC5575bis, but the text is descriptive rather than prescriptive and the cumulative intent of this proposed revision is entirely unclear to this reviewer.

It is unfortunate that RFC5575bis chose to add further validation conditions beside the three conditions labelled (a), (b) and (c) in the body of the text in Section 6. This refinement to the original three conditions (a.,b., and c.) is unclear. The revised text in this draft makes this state even more confusing. If the intent of this draft was to clarify the intent of RFC5575 as well as adding additional criteria for validation, then this does not appear to have been achieved.

It is unclear for me that the publication of RFC5575bis and the publication of this draft as further revision to RFC5575bis serves the purpose of extending the utility of the Flowspec validation procedure in a useful manner. If 5575bis is flawed in its description of a clear unambiguous validation procedure then its process through to publication should be halted and the document passed back to the WG. If, on the other hand, the WG is happy with the bis document in its current states, and happy in the light of the knowledge of the existence of this revisionm draft, then it would appear that the working group is unwilling to contemplate the revisions proposed in this draft, and the intent of this draft as a working gropup document is at best confusing.

---

From: John Scudder <[email-masked]>
Date: Fri, 3 Jul 2020 12:24:04 +0000

Hi Geoff,

> On Jul 2, 2020, at 11:49 PM, Geoff Huston <[email-masked]> wrote:
> 
> I have some major concerns about this document, mainly relating to updates to an RFC-to-be even before the original document has been published as an RFC. I assume that there are reasons why the original document (draft-ietf-idr-rfc5575bis) was not updated directly, particularly given that the initial drafts of this validation revision document predates the initial drafts rfc5575bis document. It is therefore unclear why the process of review of the 5575bis document has not adopted this revised specification during the course of the development of the bis document during its development.

I can address this. At the time we were teeing up rfc5575bis, we (the chairs, authors, and WG) made the decision to restrict its scope to clarifications of 5575 and nothing more, in particular no normative changes or extensions, in interests of moving it quickly. I can see arguments, in hindsight, for why we should have taken a different course, but that was the motivation.

Regards,

—John

---

From: "Susan Hares" <[email-masked]>
Date: Fri, 3 Jul 2020 08:32:46 -0400

John: 

Thank you for addressing this question from Geoff's review.   +1 to John's comments 

Sue 

Geoff:  

We decided to unbundle RFC5575bis, v6 additions to RFC5575bis, and this document in order to progress each document faster.  In hind sight, I also feel this was unfortunate choice.  

The purpose behind all of the additions were to correct problems found with the original RFC5575 in deployment.  

You may wish to recommend the chairs/WG merge all three drafts.  Operators have told us the same thing.   If so, we'll put that on the list of things to do.  

Sue 

-----Original Message-----
From: John Scudder [mailto:[email-masked]] 
Sent: Friday, July 3, 2020 8:24 AM
To: Geoff Huston
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: Re: RtgDir Early Review: draft-ietf-idr-bgp-flowspec-oid-11.txt

Hi Geoff,

Regards,

—John

---

From: "Juan Alcaide (jalcaide)" <[email-masked]>
Date: Fri, 3 Jul 2020 16:00:23 +0000

That was my understanding as well

Note that few parts or earlier versions of flowspec-oid were migrated to rfc5575bis when  they clarified original rfc5575 (namely, validation rule a) on section 6 of rfc5575bis)
Note also that many vendors  arealready  implementing old rfc5575 + flowspec-oid implementations.

Regarding your comments, you are right, it should say 

b.  One of the following conditions MUST hold true:

This is one of the nits we have to fix

The points labeled from 1 to 3 under a.2 are just comments on the rule a.2 (exceptions, etc). If everybody agrees there is a better way of conveying the same information, I'll be happy to do the modifications.

-J

-----Original Message-----
From: Susan Hares <[email-masked]> 
Sent: Friday, July 3, 2020 2:33 PM
To: 'John Scudder' <[email-masked]>; 'Geoff Huston' <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: RE: RtgDir Early Review: draft-ietf-idr-bgp-flowspec-oid-11.txt

John: 

Sue 

Geoff:  

Sue 

-----Original Message-----
From: John Scudder [mailto:[email-masked]] 
Sent: Friday, July 3, 2020 8:24 AM
To: Geoff Huston
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: Re: RtgDir Early Review: draft-ietf-idr-bgp-flowspec-oid-11.txt

Hi Geoff,

Regards,

—John

---

From: Geoff Huston <[email-masked]>
Date: Sat, 4 Jul 2020 06:14:55 +1000

> You may wish to recommend the chairs/WG merge all three drafts. 

Yes, that sounds like a fine recommendation and I concur. A single document in this context seems far more sensible to me than piling up revisions on top of revisions. I think the end result of a single revised document would be a lot clearer for implementors of product and network operators.

Geoff